﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.8
@EndOfDesignText@
'KeyValueStore: v2.00
Sub Class_Globals
	Private sql1 As SQL
	Private ser As B4XSerializator
End Sub

'Initializes the store and sets the store file.
Public Sub Initialize (Dir As String, FileName As String)
	If sql1.IsInitialized Then sql1.Close
#if B4J
	sql1.InitializeSQLite(Dir, FileName, True)
#else
	sql1.Initialize(Dir, FileName, True)
#end if
	CreateTable
End Sub

Public Sub Put(Key As String, Value As Object)
	sql1.ExecNonQuery2("INSERT OR REPLACE INTO main VALUES(?, ?)", Array As Object(Key, ser.ConvertObjectToBytes(Value)))
End Sub

Public Sub Get(Key As String) As Object
	Dim rs As ResultSet = sql1.ExecQuery2("SELECT value FROM main WHERE key = ?", Array As String(Key))
	Dim result As Object = Null
	If rs.NextRow Then
		result = ser.ConvertBytesToObject(rs.GetBlob2(0))
	End If
	rs.Close
	Return result
End Sub

Public Sub GetDefault(Key As String, DefaultValue As Object) As Object
	Dim res As Object = Get(Key)
	If res = Null Then Return DefaultValue
	Return res
End Sub

Public Sub PutEncrypted (Key As String, Value As Object, Password As String)
#if B4I
	Dim cipher As Cipher
#else
	Dim cipher As B4XCipher
#end if
	Put(Key, cipher.Encrypt(ser.ConvertObjectToBytes(Value), Password))
End Sub


Public Sub GetEncrypted (Key As String, Password As String) As Object
#if B4I
	Dim cipher As Cipher
#else
	Dim cipher As B4XCipher
#end if
	Dim b() As Byte = Get(Key)
	If b = Null Then Return Null
	Return ser.ConvertBytesToObject(cipher.Decrypt(b, Password))
End Sub

#if not(B4A)
Public Sub PutBitmap(Key As String, Value As Image)
	Dim out As OutputStream
	out.InitializeToBytesArray(0)
	Value.WriteToStream( out  )
	Put(Key, out.ToBytesArray)
	out.Close
End Sub

Public Sub GetBitmap(Key As String) As Image
	Dim b() As Byte = Get(Key)
	If b = Null Then Return Null
	Dim in As InputStream
	in.InitializeFromBytesArray(b, 0, b.Length)
	Dim bmp As Image
	bmp.Initialize2(in)
	in.Close
	Return bmp
End Sub

#else
Public Sub PutBitmap(Key As String, Value As Bitmap)
	Dim out As OutputStream
	out.InitializeToBytesArray(0)
	Value.WriteToStream(out, 100, "PNG")
	Put(Key, out.ToBytesArray)
	out.Close
End Sub

Public Sub GetBitmap(Key As String) As Bitmap
	Dim b() As Byte = Get(Key)
	If b = Null Then Return Null
	Dim in As InputStream
	in.InitializeFromBytesArray(b, 0, b.Length)
	Dim bmp As Bitmap
	bmp.Initialize2(in)
	in.Close
	Return bmp
End Sub
#End If

'Removes the key and value mapped to this key.
Public Sub Remove(Key As String)
	sql1.ExecNonQuery2("DELETE FROM main WHERE key = ?", Array As Object(Key))
End Sub

'Returns a list with all the keys.
Public Sub ListKeys As List
	Dim c As ResultSet = sql1.ExecQuery("SELECT key FROM main")
	Dim res As List
	res.Initialize
	Do While c.NextRow
		res.Add(c.GetString2(0))
	Loop
	c.Close
	Return res
End Sub

'Tests whether a key is available in the store.
Public Sub ContainsKey(Key As String) As Boolean
	Return sql1.ExecQuerySingleResult2("SELECT count(key) FROM main WHERE key = ?", _
		Array As String(Key)) > 0
End Sub

'Deletes all data from the store.
Public Sub DeleteAll
	sql1.ExecNonQuery("DROP TABLE main")
	CreateTable
End Sub


'Closes the store.
Public Sub Close
	sql1.Close
End Sub


'creates the main table (if it does not exist)
Private Sub CreateTable
	sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS main(key TEXT PRIMARY KEY, value NONE)")
End Sub

' don't Know if this one is necessary...
' Usage: GetAsync( Me, keyToSearch) 
' Add Sub GetDone (Result as object) to the Current Module
Public Sub GetAsync (Component As Object, key As String )
	Dim Result As Object = Null
	Dim filter As Object = sql1.ExecQueryAsync("SQL", "SELECT value FROM main WHERE key = ?", Array As String ( key) )
	Wait For (filter)  SQL_QueryComplete (Success As Boolean, Crsr As ResultSet)
	If Success Then
		If Crsr.NextRow Then
			Result  = ser.ConvertBytesToObject( Crsr.GetBlob2(0) )
		End If
	End If
	Crsr.Close
	CallSub2(Component, "GetDone", Result)
End Sub

'Usage: PutAsync( Me, MapofKeysAndValues)
' Add Sub PutDone to the Current Module
Public Sub PutAsync ( Component As Object,keyvalues As Map)
	For Each k As String In keyvalues.Keys
		sql1.AddNonQueryToBatch("INSERT OR REPLACE INTO main VALUES(?, ?)", Array As Object( k, ser.ConvertObjectToBytes( keyvalues.Get(k) ) ) )
	Next
	Dim filter As Object = sql1.ExecNonQueryBatch("SQL")
	Wait For (filter ) SQL_NonQueryComplete (Success As Boolean)
	If Success Then
		CallSub( Component, "PutDone")
	End If
End Sub


